pragma Ada_95;
pragma Warnings (Off);
pragma Source_File_Name (ada_main, Spec_File_Name => "b__if_inline.ads");
pragma Source_File_Name (ada_main, Body_File_Name => "b__if_inline.adb");
pragma Suppress (Overflow_Check);

with System.Restrictions;
with Ada.Exceptions;

package body ada_main is

   E101 : Short_Integer; pragma Import (Ada, E101, "system__os_lib_E");
   E011 : Short_Integer; pragma Import (Ada, E011, "system__soft_links_E");
   E021 : Short_Integer; pragma Import (Ada, E021, "system__exception_table_E");
   E111 : Short_Integer; pragma Import (Ada, E111, "ada__containers_E");
   E094 : Short_Integer; pragma Import (Ada, E094, "ada__io_exceptions_E");
   E049 : Short_Integer; pragma Import (Ada, E049, "ada__strings_E");
   E051 : Short_Integer; pragma Import (Ada, E051, "ada__strings__maps_E");
   E055 : Short_Integer; pragma Import (Ada, E055, "ada__strings__maps__constants_E");
   E085 : Short_Integer; pragma Import (Ada, E085, "ada__tags_E");
   E093 : Short_Integer; pragma Import (Ada, E093, "ada__streams_E");
   E039 : Short_Integer; pragma Import (Ada, E039, "interfaces__c_E");
   E218 : Short_Integer; pragma Import (Ada, E218, "interfaces__c__strings_E");
   E023 : Short_Integer; pragma Import (Ada, E023, "system__exceptions_E");
   E104 : Short_Integer; pragma Import (Ada, E104, "system__file_control_block_E");
   E196 : Short_Integer; pragma Import (Ada, E196, "ada__streams__stream_io_E");
   E096 : Short_Integer; pragma Import (Ada, E096, "system__file_io_E");
   E099 : Short_Integer; pragma Import (Ada, E099, "system__finalization_root_E");
   E097 : Short_Integer; pragma Import (Ada, E097, "ada__finalization_E");
   E174 : Short_Integer; pragma Import (Ada, E174, "system__regpat_E");
   E159 : Short_Integer; pragma Import (Ada, E159, "system__storage_pools_E");
   E155 : Short_Integer; pragma Import (Ada, E155, "system__finalization_masters_E");
   E153 : Short_Integer; pragma Import (Ada, E153, "system__storage_pools__subpools_E");
   E236 : Short_Integer; pragma Import (Ada, E236, "system__task_info_E");
   E108 : Short_Integer; pragma Import (Ada, E108, "ada__calendar_E");
   E134 : Short_Integer; pragma Import (Ada, E134, "ada__calendar__time_zones_E");
   E129 : Short_Integer; pragma Import (Ada, E129, "gnat__calendar_E");
   E147 : Short_Integer; pragma Import (Ada, E147, "gnat__calendar__time_io_E");
   E178 : Short_Integer; pragma Import (Ada, E178, "system__assertions_E");
   E063 : Short_Integer; pragma Import (Ada, E063, "system__object_reader_E");
   E044 : Short_Integer; pragma Import (Ada, E044, "system__dwarf_lines_E");
   E190 : Short_Integer; pragma Import (Ada, E190, "system__pool_global_E");
   E015 : Short_Integer; pragma Import (Ada, E015, "system__secondary_stack_E");
   E149 : Short_Integer; pragma Import (Ada, E149, "ada__strings__unbounded_E");
   E208 : Short_Integer; pragma Import (Ada, E208, "ada__directories_E");
   E214 : Short_Integer; pragma Import (Ada, E214, "system__regexp_E");
   E246 : Short_Integer; pragma Import (Ada, E246, "system__tasking__initialization_E");
   E034 : Short_Integer; pragma Import (Ada, E034, "system__traceback__symbolic_E");
   E091 : Short_Integer; pragma Import (Ada, E091, "ada__text_io_E");
   E256 : Short_Integer; pragma Import (Ada, E256, "system__tasking__protected_objects_E");
   E260 : Short_Integer; pragma Import (Ada, E260, "system__tasking__protected_objects__entries_E");
   E254 : Short_Integer; pragma Import (Ada, E254, "system__tasking__queuing_E");
   E220 : Short_Integer; pragma Import (Ada, E220, "templates_parser_tasking_E");
   E106 : Short_Integer; pragma Import (Ada, E106, "templates_parser_E");
   E202 : Short_Integer; pragma Import (Ada, E202, "templates_parser__input_E");
   E204 : Short_Integer; pragma Import (Ada, E204, "templates_parser__utils_E");

   Local_Priority_Specific_Dispatching : constant String := "";
   Local_Interrupt_States : constant String := "";

   Is_Elaborated : Boolean := False;

   procedure finalize_library is
   begin
      declare
         procedure F1;
         pragma Import (Ada, F1, "templates_parser__finalize_body");
      begin
         E106 := E106 - 1;
         F1;
      end;
      declare
         procedure F2;
         pragma Import (Ada, F2, "templates_parser__finalize_spec");
      begin
         F2;
      end;
      declare
         procedure F3;
         pragma Import (Ada, F3, "templates_parser_tasking__finalize_body");
      begin
         E220 := E220 - 1;
         F3;
      end;
      E260 := E260 - 1;
      declare
         procedure F4;
         pragma Import (Ada, F4, "system__tasking__protected_objects__entries__finalize_spec");
      begin
         F4;
      end;
      E091 := E091 - 1;
      declare
         procedure F5;
         pragma Import (Ada, F5, "ada__text_io__finalize_spec");
      begin
         F5;
      end;
      E208 := E208 - 1;
      E214 := E214 - 1;
      declare
         procedure F6;
         pragma Import (Ada, F6, "system__regexp__finalize_spec");
      begin
         F6;
      end;
      declare
         procedure F7;
         pragma Import (Ada, F7, "ada__directories__finalize_spec");
      begin
         F7;
      end;
      E149 := E149 - 1;
      declare
         procedure F8;
         pragma Import (Ada, F8, "ada__strings__unbounded__finalize_spec");
      begin
         F8;
      end;
      declare
         procedure F9;
         pragma Import (Ada, F9, "system__file_io__finalize_body");
      begin
         E096 := E096 - 1;
         F9;
      end;
      E155 := E155 - 1;
      E153 := E153 - 1;
      E190 := E190 - 1;
      declare
         procedure F10;
         pragma Import (Ada, F10, "system__pool_global__finalize_spec");
      begin
         F10;
      end;
      declare
         procedure F11;
         pragma Import (Ada, F11, "system__storage_pools__subpools__finalize_spec");
      begin
         F11;
      end;
      declare
         procedure F12;
         pragma Import (Ada, F12, "system__finalization_masters__finalize_spec");
      begin
         F12;
      end;
      E196 := E196 - 1;
      declare
         procedure F13;
         pragma Import (Ada, F13, "ada__streams__stream_io__finalize_spec");
      begin
         F13;
      end;
      declare
         procedure Reraise_Library_Exception_If_Any;
            pragma Import (Ada, Reraise_Library_Exception_If_Any, "__gnat_reraise_library_exception_if_any");
      begin
         Reraise_Library_Exception_If_Any;
      end;
   end finalize_library;

   procedure adafinal is
      procedure s_stalib_adafinal;
      pragma Import (C, s_stalib_adafinal, "system__standard_library__adafinal");

      procedure Runtime_Finalize;
      pragma Import (C, Runtime_Finalize, "__gnat_runtime_finalize");

   begin
      if not Is_Elaborated then
         return;
      end if;
      Is_Elaborated := False;
      Runtime_Finalize;
      s_stalib_adafinal;
   end adafinal;

   type No_Param_Proc is access procedure;

   procedure adainit is
      Main_Priority : Integer;
      pragma Import (C, Main_Priority, "__gl_main_priority");
      Time_Slice_Value : Integer;
      pragma Import (C, Time_Slice_Value, "__gl_time_slice_val");
      WC_Encoding : Character;
      pragma Import (C, WC_Encoding, "__gl_wc_encoding");
      Locking_Policy : Character;
      pragma Import (C, Locking_Policy, "__gl_locking_policy");
      Queuing_Policy : Character;
      pragma Import (C, Queuing_Policy, "__gl_queuing_policy");
      Task_Dispatching_Policy : Character;
      pragma Import (C, Task_Dispatching_Policy, "__gl_task_dispatching_policy");
      Priority_Specific_Dispatching : System.Address;
      pragma Import (C, Priority_Specific_Dispatching, "__gl_priority_specific_dispatching");
      Num_Specific_Dispatching : Integer;
      pragma Import (C, Num_Specific_Dispatching, "__gl_num_specific_dispatching");
      Main_CPU : Integer;
      pragma Import (C, Main_CPU, "__gl_main_cpu");
      Interrupt_States : System.Address;
      pragma Import (C, Interrupt_States, "__gl_interrupt_states");
      Num_Interrupt_States : Integer;
      pragma Import (C, Num_Interrupt_States, "__gl_num_interrupt_states");
      Unreserve_All_Interrupts : Integer;
      pragma Import (C, Unreserve_All_Interrupts, "__gl_unreserve_all_interrupts");
      Detect_Blocking : Integer;
      pragma Import (C, Detect_Blocking, "__gl_detect_blocking");
      Default_Stack_Size : Integer;
      pragma Import (C, Default_Stack_Size, "__gl_default_stack_size");
      Leap_Seconds_Support : Integer;
      pragma Import (C, Leap_Seconds_Support, "__gl_leap_seconds_support");
      Bind_Env_Addr : System.Address;
      pragma Import (C, Bind_Env_Addr, "__gl_bind_env_addr");

      procedure Runtime_Initialize (Install_Handler : Integer);
      pragma Import (C, Runtime_Initialize, "__gnat_runtime_initialize");

      Finalize_Library_Objects : No_Param_Proc;
      pragma Import (C, Finalize_Library_Objects, "__gnat_finalize_library_objects");
   begin
      if Is_Elaborated then
         return;
      end if;
      Is_Elaborated := True;
      Main_Priority := -1;
      Time_Slice_Value := -1;
      WC_Encoding := 'b';
      Locking_Policy := ' ';
      Queuing_Policy := ' ';
      Task_Dispatching_Policy := ' ';
      System.Restrictions.Run_Time_Restrictions :=
        (Set =>
          (False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False, False, True, False, False, False, 
           False, False, False, False, False, False, False, False, 
           False, False, False),
         Value => (0, 0, 0, 0, 0, 0, 0, 0, 0, 0),
         Violated =>
          (True, False, False, True, True, False, False, True, 
           False, False, True, True, True, True, False, False, 
           True, False, False, True, True, False, True, True, 
           False, True, True, True, True, False, False, False, 
           False, False, True, False, False, True, False, True, 
           False, True, True, False, False, True, True, False, 
           False, False, True, False, True, False, False, False, 
           False, False, False, False, True, True, True, False, 
           False, True, False, True, True, True, False, True, 
           True, False, True, True, True, True, False, False, 
           True, False, False, False, True, False, False, False, 
           False, True, False),
         Count => (0, 0, 0, 2, 0, 0, 0, 0, 1, 0),
         Unknown => (False, False, False, False, False, False, False, False, True, False));
      Priority_Specific_Dispatching :=
        Local_Priority_Specific_Dispatching'Address;
      Num_Specific_Dispatching := 0;
      Main_CPU := -1;
      Interrupt_States := Local_Interrupt_States'Address;
      Num_Interrupt_States := 0;
      Unreserve_All_Interrupts := 0;
      Detect_Blocking := 0;
      Default_Stack_Size := -1;
      Leap_Seconds_Support := 0;

      Runtime_Initialize (1);

      Finalize_Library_Objects := finalize_library'access;

      System.Soft_Links'Elab_Spec;
      System.Exception_Table'Elab_Body;
      E021 := E021 + 1;
      Ada.Containers'Elab_Spec;
      E111 := E111 + 1;
      Ada.Io_Exceptions'Elab_Spec;
      E094 := E094 + 1;
      Ada.Strings'Elab_Spec;
      E049 := E049 + 1;
      Ada.Strings.Maps'Elab_Spec;
      Ada.Strings.Maps.Constants'Elab_Spec;
      E055 := E055 + 1;
      Ada.Tags'Elab_Spec;
      Ada.Streams'Elab_Spec;
      E093 := E093 + 1;
      Interfaces.C'Elab_Spec;
      Interfaces.C.Strings'Elab_Spec;
      System.Exceptions'Elab_Spec;
      E023 := E023 + 1;
      System.File_Control_Block'Elab_Spec;
      E104 := E104 + 1;
      Ada.Streams.Stream_Io'Elab_Spec;
      E196 := E196 + 1;
      System.Finalization_Root'Elab_Spec;
      E099 := E099 + 1;
      Ada.Finalization'Elab_Spec;
      E097 := E097 + 1;
      System.Regpat'Elab_Spec;
      System.Storage_Pools'Elab_Spec;
      E159 := E159 + 1;
      System.Finalization_Masters'Elab_Spec;
      System.Storage_Pools.Subpools'Elab_Spec;
      System.Task_Info'Elab_Spec;
      E236 := E236 + 1;
      Ada.Calendar'Elab_Spec;
      Ada.Calendar'Elab_Body;
      E108 := E108 + 1;
      Ada.Calendar.Time_Zones'Elab_Spec;
      E134 := E134 + 1;
      Gnat.Calendar'Elab_Spec;
      E129 := E129 + 1;
      Gnat.Calendar.Time_Io'Elab_Spec;
      System.Assertions'Elab_Spec;
      E178 := E178 + 1;
      System.Object_Reader'Elab_Spec;
      System.Dwarf_Lines'Elab_Spec;
      System.Pool_Global'Elab_Spec;
      E190 := E190 + 1;
      E153 := E153 + 1;
      System.Finalization_Masters'Elab_Body;
      E155 := E155 + 1;
      E174 := E174 + 1;
      System.File_Io'Elab_Body;
      E096 := E096 + 1;
      E218 := E218 + 1;
      E039 := E039 + 1;
      Ada.Tags'Elab_Body;
      E085 := E085 + 1;
      E051 := E051 + 1;
      System.Soft_Links'Elab_Body;
      E011 := E011 + 1;
      System.Os_Lib'Elab_Body;
      E101 := E101 + 1;
      System.Secondary_Stack'Elab_Body;
      E015 := E015 + 1;
      E044 := E044 + 1;
      E063 := E063 + 1;
      Ada.Strings.Unbounded'Elab_Spec;
      E149 := E149 + 1;
      Ada.Directories'Elab_Spec;
      System.Regexp'Elab_Spec;
      E214 := E214 + 1;
      Ada.Directories'Elab_Body;
      E208 := E208 + 1;
      System.Traceback.Symbolic'Elab_Body;
      E034 := E034 + 1;
      System.Tasking.Initialization'Elab_Body;
      E246 := E246 + 1;
      Ada.Text_Io'Elab_Spec;
      Ada.Text_Io'Elab_Body;
      E091 := E091 + 1;
      E147 := E147 + 1;
      System.Tasking.Protected_Objects'Elab_Body;
      E256 := E256 + 1;
      System.Tasking.Protected_Objects.Entries'Elab_Spec;
      E260 := E260 + 1;
      System.Tasking.Queuing'Elab_Body;
      E254 := E254 + 1;
      Templates_Parser_Tasking'Elab_Body;
      E220 := E220 + 1;
      Templates_Parser'Elab_Spec;
      Templates_Parser.Input'Elab_Spec;
      E202 := E202 + 1;
      Templates_Parser.Utils'Elab_Spec;
      E204 := E204 + 1;
      Templates_Parser'Elab_Body;
      E106 := E106 + 1;
   end adainit;

   procedure Ada_Main_Program;
   pragma Import (Ada, Ada_Main_Program, "_ada_if_inline");

   function main
     (argc : Integer;
      argv : System.Address;
      envp : System.Address)
      return Integer
   is
      procedure Initialize (Addr : System.Address);
      pragma Import (C, Initialize, "__gnat_initialize");

      procedure Finalize;
      pragma Import (C, Finalize, "__gnat_finalize");
      SEH : aliased array (1 .. 2) of Integer;

      Ensure_Reference : aliased System.Address := Ada_Main_Program_Name'Address;
      pragma Volatile (Ensure_Reference);

   begin
      gnat_argc := argc;
      gnat_argv := argv;
      gnat_envp := envp;

      Initialize (SEH'Address);
      adainit;
      Ada_Main_Program;
      adafinal;
      Finalize;
      return (gnat_exit_status);
   end;

--  BEGIN Object file/option list
   --   /hangzhou.a/gnatmail/sandbox/gpl-2016-src/tmp/cache/aws-src/templates_parser/docs/build/obj/if_inline.o
   --   -L/hangzhou.a/gnatmail/sandbox/gpl-2016-src/tmp/cache/aws-src/templates_parser/docs/build/obj/
   --   -L/hangzhou.a/gnatmail/sandbox/gpl-2016-src/tmp/cache/aws-src/templates_parser/docs/build/obj/
   --   -L/hangzhou.a/gnatmail/sandbox/gpl-2016-src/tmp/cache/aws-src/templates_parser/.build/lib/
   --   -L/hangzhou.a/gnatmail/sandbox/gpl-2016-src/x86_64-linux/stable-gnat/install/lib/xmlada/xmlada_unicode.static/
   --   -L/hangzhou.a/gnatmail/sandbox/gpl-2016-src/x86_64-linux/stable-gnat/install/lib/xmlada/xmlada_sax.static/
   --   -L/hangzhou.a/gnatmail/sandbox/gpl-2016-src/x86_64-linux/stable-gnat/install/lib/xmlada/xmlada_input.static/
   --   -L/hangzhou.a/gnatmail/sandbox/gpl-2016-src/x86_64-linux/stable-gnat/install/lib/xmlada/xmlada_dom.static/
   --   -L/hangzhou.a/gnatmail/sandbox/gpl-2016-src/x86_64-linux/stable-gnat/install/lib/xmlada/xmlada_schema.static/
   --   -L/hangzhou.a/gnatmail/sandbox/gpl-2016-src/x86_64-linux/stable-gnat/install/lib/gcc/x86_64-pc-linux-gnu/4.9.4/adalib/
   --   -static
   --   -lgnarl
   --   -lgnat
   --   -ldl
   --   -lpthread
   --   -lrt
--  END Object file/option list   

end ada_main;
